#!/usr/bin/python
import os, os.path, sys, pickle, re, copy, glob
from classGraph import Graph, Data, Clause
from toolLog import Log
import mappingTools
import pdb

org_parameters = None
if len(sys.argv) > 1:
    if os.path.isfile(sys.argv[1]):
        fp = open(sys.argv[1])
        org_parameters = mappingTools.readParameters(fp)
        fp.close()
    elif len(sys.argv) > 2:
        org_parameters = mappingTools.readParameters()
        org_parameters['id_exp'] = sys.argv[1]
        org_parameters['graph_file'] = sys.argv[2]
        if len(sys.argv) > 3:
            org_parameters['preds_file'] = sys.argv[3]
if org_parameters is None:
    Warning("No parameters given")
    exit()

data_parameters = dict(org_parameters)
data_parameters['log'] = Log(data_parameters['verbosity'], data_parameters['logfile'])
Graph.log = data_parameters['log']

data = Data()

#### Load predicates info from file 
if data_parameters.has_key('preds_file'):
    fp = open(data_parameters['data_rep'] + data_parameters['preds_file'])
    data.parsePreds(fp)
    fp.close()

#### Load data network from file 
if data_parameters.has_key('graph_file'):
    data.loadGraph(data_parameters['data_rep'] + data_parameters['graph_file'])
else:
    Warning("No data given")
    exit()

# data.writeGraph(data_parameters['data_rep'] + data_parameters['graph_file']+".bmg")
# exit()


to_load = None
# fp = open("../data/debugSelected.pickle")
# selected = pickle.load(fp)
# fp.close()

# to_load = set()
# for patt_id in selected:
#     to_load.add('.'.join(patt_id))
#     to_load.add('.'.join(patt_id[:1]))


id_o = data_parameters['id_exp'] 
patt = data_parameters['results_rep']+id_o+"_clauses.bmg"
# mtch = data_parameters['results_rep']+"(?P<id>"+re.sub("\*",".*", id_o)+")_clauses.bmg"
mtch = data_parameters['results_rep']+"("+re.sub("\*",".*", id_o)+")_clauses.bmg"
mtchs = re.sub("\*",".*", id_o)
for clauses_filename in glob.glob(patt):
    data_parameters['id_exp'] = re.sub(mtch, r"\1", clauses_filename)
    print data_parameters['id_exp']
    
    multiples = []
    supports_dict = {}
    collect_clauses = {}
    # #### Generate init clauses from predicates
    for pred, valsd in data.graph.elems_pred[Graph.EG].items():
        for val in valsd.keys():
            clauses = mappingTools.initClauses(pred, val, data, data_parameters)
            for clause in clauses:

                patt_key = tuple([clause.getId()])
                supp_key = clause.supportKeyStr(data.graph)

                if not supports_dict.has_key(supp_key):
                    supports_dict[supp_key] = []
                elif len(supports_dict[supp_key]) == 1:
                    multiples.append(supp_key)
                supports_dict[supp_key].append(patt_key)

                collect_clauses[patt_key] = clause
                
    #### Load init clauses from file
    if True:
        clausesData = Data(data.toClausePreds())
        graphs, labels = clausesData.readGraphs(clauses_filename)

        # nodes = graphs[None].getNodes(False) 
        # for node, atts in nodes: 
        #     sp = node.split('.')[:-1]
        #     if len(sp) > 0:
        #         '.'.join(sp)
        #         graphs[None].parseElem(Graph.EG, (node, '.'.join(sp)), "parent", "EG")
        # neigh_dict = graphs[None].neighborsSub(1)

        # dict_bases = {}
        # for n,k in neigh_dict.items():
        #     if len(k) == 0:
        #         dict_bases.setdefault(n.split('.')[0], []).append((float(graphs[None].getElem(n).get('jaccard', '0')), n))

        # pdb.set_trace()
        # to_load = set()
        # for node, atts in graphs[None].getNodes(): 
        #     if len(neigh_dict[node]) == 0 and float(atts.get('jaccard', '0')) > 0.90*data_parameters['min_jaccard']:
        #         to_load.add(node)
        #         sp = node.split('.')[:-1]
        #         if len(sp) > 0:
        #             to_load.add('.'.join(sp))

        # pdb.set_trace()
        # li = 0
        # for label in to_load:
        #     if li % 25 == 0:
        #         data_parameters["log"].printL(4, "Mapped %d of %d" % (li, len(to_load)))
        #     li +=1

        for label in labels.keys():
            if labels.has_key(label):            
                clause = Clause(label, graphs[labels[label]], data.graph, data_parameters['query_nodes'])
                if clause.support() is None:
                    data_parameters["log"].printL(3, "Could not remap %s" % clause.getId())
                    continue

                patt_key = tuple(label.split('.'))
                supp_key = clause.supportKeyStr(data.graph)

                if not supports_dict.has_key(supp_key):
                    supports_dict[supp_key] = []
                elif len(supports_dict[supp_key]) == 1:
                    multiples.append(supp_key)
                supports_dict[supp_key].append(patt_key)

                collect_clauses[patt_key] = clause

	##### PROCESS MULTIPLES TO CHECK FOR REDS
	cands_red = []
	for supp_key in multiples:
	    for pi, patt_keyi in enumerate(supports_dict[supp_key]):
	        for patt_keyj in supports_dict[supp_key][:pi]:
	            invert = (collect_clauses[patt_keyi].ordSupport() == collect_clauses[patt_keyj].ordSupport())
	            if len(set(collect_clauses[patt_keyi].getTypesPred()) & set(collect_clauses[patt_keyj].getTypesPred())) == 0:
	                cands_red.append((patt_keyi, patt_keyj, invert))
	
	            for kip in range(1,len(patt_keyi)):
	                if patt_keyi[:kip] != patt_keyj[:kip] and collect_clauses.has_key(patt_keyi[:kip]) and len(set(collect_clauses[patt_keyi[:kip]].getTypesPred()) & set(collect_clauses[patt_keyj].getTypesPred())) == 0:
	                    cands_red.append((patt_keyi[:kip], patt_keyj, invert))
	
	            for kjp in range(1,len(patt_keyj)):
	                if patt_keyi[:kjp] != patt_keyj[:kjp] and collect_clauses.has_key(patt_keyj[:kjp]) and len(set(collect_clauses[patt_keyi].getTypesPred()) & set(collect_clauses[patt_keyj[:kjp]].getTypesPred())) == 0:
	                    cands_red.append((patt_keyi, patt_keyj[:kjp], invert))
	

	##### PROCESS PARENT CHILD TO CHECK FOR REDS
	for patt_key in collect_clauses.keys():
	    if collect_clauses.has_key(patt_key[:-1]):
	        cands_red.append((patt_key[:-1], patt_key, True))
 	
    # exit()

    limit_mappable=0
    additional_qrn = ["p"+chr(k) for k in range(ord("B"), ord("Z"))]
    reds = []
    inter_insts = {}
    for pki, tmp in enumerate(cands_red):

        data_parameters["log"].printL(4, "Now %d %s" % (pki, tmp))
        if len(tmp[0]) > 1:
            used_keys = set(tmp[:2])
        else:
            used_keys = set([tmp[1]])
        patt_keys = list(tmp[:2])    
        qrns = data_parameters['query_nodes']
        clauses = [collect_clauses[patt_keys[0]], collect_clauses[patt_keys[1]]]
        if not tmp[2]:
            clauses[0] = clauses[0].copy()
            clauses[0].setId("INV%d.%d" % (pki, 0))

            patt_keys[1] = tuple(list(patt_keys[1])+["INV"])
            cst_tmp = clauses[1].constraints.copy()
            map_tmp = clauses[1].nodes_map.copy()
            for nfrom, nto, upd in [("pA", "tmp", False), ("pZ", "pA", False), ("tmp", "pZ", True)]:
                cst_tmp.translateNode(nfrom, nto, upd)
                map_tmp.translateNode(nfrom, nto)
            clauses[1] = Clause("INV%d.%d" % (pki, 1), cst_tmp, map_tmp, qrns)

        EL = clauses[0].support(); ER = clauses[1].support()
        E11 = EL & ER; E10 = EL - ER; E01 = ER - EL
        if len(E11) > 0:
            acc = len(E11)/float(len(E10)+len(E01)+len(E11))
        else: acc = 0

        org_acc = acc
        cards = (len(E11), len(E10), len(E01))
        inter_tuples = list(E11)
        support_E11 = set([tuple(sorted(e)) for e in E11])

        ######### CHECK for possible nodes to map 
        inter_loc = [None, None]
        for side in [0,1]:
            if not inter_insts.has_key(patt_keys[side]):
                inter_insts[patt_keys[side]] = clauses[side].instancesQTDict()
            inter_loc[side] = inter_insts[patt_keys[side]]

        candidates_map = []
        for nodeL in inter_loc[0].keys():
            for nodeR in inter_loc[1].keys():
                mappable = len(inter_loc[0][nodeL]['maps_to'] & inter_loc[1][nodeR]['maps_to'])
                i = 0
                while mappable > limit_mappable and i < len(inter_tuples):
                    top = len(inter_loc[0][nodeL]['instances'][inter_tuples[i]] & inter_loc[1][nodeR]['instances'][inter_tuples[i]])
                    bottom = len(inter_loc[0][nodeL]['instances'][inter_tuples[i]] | inter_loc[1][nodeR]['instances'][inter_tuples[i]])
                    if top == 0:
                        mappable = 0
                    else:
                        mappable = min(mappable, top/float(bottom))
                    i +=1
                if mappable > limit_mappable:
                    candidates_map.append((nodeL, nodeR, mappable))
	
        candidates_map.sort(key=lambda x: x[-1])
        trans = [set(), set()]
        nfrom = [None, None]
        translated = []
        ti = 0
        if len(candidates_map) > 0:
            data_parameters["log"].printL(4, "Candidates map %d %s" % (pki, candidates_map))
        while len(candidates_map)> 0 and ti < len(additional_qrn):
            nfrom[0], nfrom[1], score = candidates_map.pop()
            new_qrn = additional_qrn[ti]
            ti += 1
            if nfrom[0] not in trans[0] and nfrom[1] not in trans[1]:
                qrns_tmp = qrns[:-1]+[new_qrn, qrns[-1]]
                clauses_tmp = [None, None]
                acc_tmp = 0
                for side in [0,1]:
                    trans[side].add(nfrom[side])
                    cst_tmp = clauses[side].constraints.copy()
                    cst_tmp.translateNode(nfrom[side], new_qrn)
                    map_tmp = clauses[side].nodes_map.copy()
                    map_tmp.translateNode(nfrom[side], new_qrn)
                    clauses_tmp[side] = Clause("RED%d.%d" % (pki, side), cst_tmp, map_tmp, qrns_tmp)

                if clauses_tmp[side].support() is not None and clauses_tmp[side].support() is not None:
                    EL = clauses_tmp[0].support(); ER = clauses_tmp[1].support()
                    E11 = EL & ER; E10 = EL - ER; E01 = ER -EL
                    if len(E11) > 0:
                        acc_tmp = len(E11)/float(len(E10)+len(E01)+len(E11))

                if acc_tmp >= acc:
                    translated.append(new_qrn)
                    clauses = clauses_tmp
                    qrns = qrns_tmp
                    cards = (len(E11), len(E10), len(E01))
                    support_E11 = set([tuple(sorted(e)) for e in E11])
                    acc = acc_tmp
        if len(translated) > 0:
            data_parameters["log"].printL(3, "TRANSLATED: %s %f vs. %f" % ( translated, acc, org_acc))
        ### WARNING support_E11 is reordered pairs
        reds.append({'clauses': clauses, 'support_E11': support_E11, 'cards': cards, 'acc': acc, 'used_keys': used_keys})
	
    reds.sort(key=lambda x: (x['acc'], x["cards"][0]))
    covered = set()
    used = set()
    selected = []

    while len(reds) > 0:
        next_red = reds.pop()

        if data_parameters['limit_contrib'] < 0:
            tmp_contrib = abs(data_parameters['limit_contrib'])*len(next_red['support_E11'])
        else:
            tmp_contrib = data_parameters['limit_contrib']


        if next_red['acc'] > data_parameters['min_jaccard'] and \
               len(next_red['used_keys'] & used) == 0 and \
               len(next_red['support_E11']) > data_parameters['min_examples'] and \
               len(next_red['support_E11'] - covered) > tmp_contrib:

            selected.append(next_red)
            used.update(next_red['used_keys'])
            covered.update(next_red['support_E11'])

    # fp = open("../data/debugSelected.pickle", "w")
    # pickle.dump(selected, fp)
    # fp.close()

    filename = data_parameters['results_rep']+("%s_redescriptions.bmg" % data_parameters['id_exp'])
    fr = open(filename, "w")
    anchor = data_parameters["query_nodes"][0]

    for pki, sel in enumerate(selected):

        fr.write("# _attributes R_Red%s E11=%d E10=%d E01=%d jaccard=%f\n" % (pki, sel['cards'][0], sel['cards'][1], sel['cards'][2], sel['acc']))
        fr.write("R_Red%s R_Red%s.R redescription\n" % (pki, pki))
        fr.write("R_Red%s T_%d.L:%s\n" % (pki, pki, anchor))
        fr.write("\n".join(sorted(sel['clauses'][0].listBMG(r'^([a-z])([0-9A-Z:.]*)$', ('T_%d.L:' % pki) +r'\1\2', None, None))) + "\n")

        fr.write("R_Red%s.R T_%d.R:%s\n" % (pki, pki, anchor))
        fr.write("\n".join(sorted(sel['clauses'][1].listBMG(r'^([a-z])([0-9A-Z:.]*)$', ('T_%d.R:' % pki) +r'\1\2', None, None))) + "\n")
    fr.close()
